library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity counters_bench is
end counters_bench;

architecture Behavioral of counters_bench is

component counters is Port(
	Clock: in std_logic;
	Load: in std_logic;
	Data_in: in std_logic_vector(31 downto 0);
	Data_out: out std_logic);
end component;

signal Clock: std_logic:='0';
signal Load: std_logic:='0';
signal Data_in: std_logic_vector(31 downto 0):=(others => '0');
signal Data_out: std_logic:='0';

begin

Clock <= not Clock after 2 ns;

process begin
	wait for 20 ns;
	Data_in <= x"00000064";
	Load <= '1';
	wait for 4 ns;
	Load <= '0';
	wait for 500 ns;
	Data_in <= x"00000032";
	Load <= '1';
	wait for 4 ns;
	Load <= '0';
	wait;
end process;

uut: counters Port map(
	Clock => Clock,
	Load => Load,
	Data_in => Data_in,
	Data_out => Data_out);

end Behavioral;