library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

-- signed, load data_in -1, count down, compare with -1.

entity counter is Port(
	Clock: in std_logic;
	Load: in std_logic;
	Data_in: in std_logic_vector(31 downto 0);
	Data_out: out std_logic);
end counter;

architecture Behavioral of counter is

signal Data: signed(32 downto 0):=(others => '1');

begin

process begin
	wait until rising_edge(Clock);
	Data <= Data -1;
	Data_out <= '0';
	
	if Data = -1 then
		Data <= Data;
		Data_out <= '1';
	end if;
	
	if Load = '1' then
		Data <= signed('0' & Data_in) -1;
	end if;
end process;

end Behavioral;