library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

-- load 0, count up, compare with buffered Data_in.

entity counter is Port(
	Clock: in std_logic;
	Load: in std_logic;
	Data_in: in std_logic_vector(31 downto 0);
	Data_out: out std_logic);
end counter;

architecture Behavioral of counter is

signal Data: unsigned(31 downto 0):=(others => '0');
signal Data_max: unsigned(31 downto 0):=(others => '0');

begin

process begin
	wait until rising_edge(Clock);
	Data <= Data +1;
	Data_out <= '0';
	
	if Data = Data_max then
		Data <= Data;
		Data_out <= '1';
	end if;
	
	if Load = '1' then
		Data <= (others => '0');
		Data_max <= unsigned(Data_in);
	end if;
end process;

end Behavioral;