library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

-- IP counter, DSP48, count up.

entity counter is Port(
	Clock: in std_logic;
	Load: in std_logic;
	Data_in: in std_logic_vector(31 downto 0);
	Data_out: out std_logic);
end counter;

architecture Behavioral of counter is

COMPONENT ip_counter_9
  PORT (
    CLK : IN STD_LOGIC;
    LOAD : IN STD_LOGIC;
    L : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    THRESH0 : OUT STD_LOGIC;
    Q : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
  );
END COMPONENT;

signal Data_out_reg: std_logic_vector(31 downto 0):=(others => '0');

begin

inst_ip_counter_9: ip_counter_9 PORT map(
	CLK  => Clock,
	LOAD => Load,
	L => std_logic_vector("11111111111111111111111111111111" - unsigned(Data_in)),
	THRESH0 => open,
	Q => Data_out_reg);

Data_out <= not Data_out_reg(31);

end Behavioral;