library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity counters is Port(
	Clock: in std_logic;
	Load: in std_logic;
	Data_in: in std_logic_vector(31 downto 0);
	Data_out: out std_logic);
end counters;

architecture Behavioral of counters is

component counter is Port(
	Clock: in std_logic;
	Load: in std_logic;
	Data_in: in std_logic_vector(31 downto 0);
	Data_out: out std_logic);
end component;

signal Load_reg: std_logic:='0';
signal Data_in_reg: std_logic_vector(31 downto 0):=(others => '0');

begin

process begin
	wait until rising_edge(Clock);
	Load_reg <= Load;
	Data_in_reg <= Data_in;
end process;

inst_counter: counter Port map(
	Clock => Clock,
	Load => Load_reg,
	Data_in => Data_in_reg,
	Data_out => Data_out);

end Behavioral;